// C Source File
// Created 3/3/2005; 7:17:28 PM


#include "defs.h"

// Main Function
void _main(void)
{
	HANDLE current=loadLevel();
	LEVEL *fptr;
	short pos=0,x=0,y=0,i,j,key;
	char num[sizeof("xxxxx")],k2nd;
	if(current){
		fptr=HeapDeref(current);
		BlackScreen();
		for(;;){
			//draw pos
			sprintf(num,"%5u",pos);
			DrawStr(3,3,"Wall#:",A_REVERSE);
			DrawStr(3,13,num,A_REVERSE);
			//draw size
			DrawStr(8,23,"Size:",A_REVERSE);
			sprintf(num,"%5u",fptr->symsize+2);
			DrawStr(3,33,num,A_REVERSE);
			//draw tiles
			for(i=0;i<4;i++){
				for(j=0;j<4;j++){
					Tile(40+20*i,15+20*j,testWall(fptr->dat[pos].Wnum,i,j));
				}
			}
			//draw selector square
			select(40+x*20,15+20*y);
			key=getKey();
			k2nd=remove2nd(key);
			//key&=0x0FFF;
			switch(key){
				case KEY_UP|KEY_LEFT:
					if(x>0)x--;
				case KEY_UP:
					if(y>0)y--;
				break;
				case KEY_DOWN|KEY_RIGHT:
					if(x<3)x++;
				case KEY_DOWN:
					if(y<3)y++;
				break;
				case KEY_DOWN|KEY_LEFT:
					if(y<3)y++;
				case KEY_LEFT:
					if(x>0)x--;
				break;
				case KEY_UP|KEY_RIGHT:
					if(y>0)y--;
				case KEY_RIGHT:
					if(x<3)x++;
				break;
				case KEY_ENTER:
					setWall(fptr->dat[pos],x,y);
					//asm("bchg.b %[bit],(%[wrd].w,%[addr])"::[addr]"a"(&fptr->dat[pos].Wnum),[bit]"d"(8-(x+1+4*y)),[wrd]"d"((short)(y>1?1:0)));
					//asm("bchg.l %1,(%0)"::"a"(&fptr->dat[pos]),"d"(16-(x+4*(y))));
				break;
				case '+':
					if((unsigned)pos>=(fptr->symsize-10)/2){
						short didRealloc=HeapRealloc(current,fptr->symsize+2+sizeof(WALL)+7);
						fptr=HeapDeref(current);
						if(didRealloc){
							fptr->symsize+=sizeof(WALL);
							memcpy(((void*)fptr)+fptr->symsize+2-8,((char[8]){0,'\0','F','D','3','D','\0','\xF8'}),8);
							pos++;
							fptr->dat[pos].Wnum=0xFFFF;
						}
					}else{
						pos++;
						if(k2nd)
							for(i=0;fptr->dat[pos+1].Wnum && i<9;i++,pos++);
					}
				break;
				case '-':
					if(pos>0){
						if(k2nd){
							if(pos>10)pos-=10;
							else pos=0;
						}else pos--;
					}else pos=(fptr->symsize-10)/2;
				break;
				case ')':
					pos=(fptr->symsize-10)/2;
				break;
				case '(':
					pos=0;
				break;
				case KEY_BACKSPACE:
					if(!k2nd){
						if(fptr->symsize>sizeof(WALL)+8){
							memmove(&fptr->dat[pos],((void*)(&fptr->dat[pos]))+2,fptr->symsize-pos-2);
							fptr->symsize-=2;
							//note HeapReallocc while never fail because the handle is shrinking
							HeapRealloc(current,fptr->symsize+sizeof(WALL)+7);
							if(!fptr->dat[pos].Wnum)pos--;
						}
					}else{
						short didRealloc=HeapRealloc(current,fptr->symsize+2+sizeof(WALL)+7);
						//we have to refresh fptr no matter what the result was because
						fptr=HeapDeref(current);
						if(didRealloc){
							memmove(((void*)&fptr->dat[pos])+2,&fptr->dat[pos],fptr->symsize-pos+2);
							fptr->symsize+=sizeof(WALL);
							pos++;
							fptr->dat[pos].Wnum=0xFFFF;
						}
					}
				break;
				case KEY_F1...KEY_F8:
					fptr->dat[pos]=randomizeWall((key-KEY_F1)+1);
				break;
				case KEY_ESC:
					goto exit;
			}
		}
	}

	exit:
	#ifndef SAVE_SCREEN
		//this is HSR, by Greg Dietsche, converted into C so it can use F line or Optomized Romcalls
		//and so it can show a coustem message on the statline
		setDirty();
		#ifdef USE_TI89
	  	memset(LCD_MEM+93*30,0xFF,20);
	  #endif
	  #if defined(USE_TI92PLUS) || defined(USE_V200)
	  	memset(LCD_MEM+121*30,0xFF,30);
	  #endif
	  //redraw Home Screen Menu
	  MenuUpdate();
	  #ifndef NO_EXIT_MSG
		  ST_helpMsg("Fall Down 3D 4x4 "VERSION_STR" level Editor");
		#else
	  	ST_reset();
		#endif
  #endif
}

short getKey(void){
	for(;;){
		register short key=GKeyIn(NULL,0);
		if(key!=KEY_OFF){
			key&=0x1FFF;
			//no translating is done if it is oncasc incompatible
			#if defined(USE_TI89) && (defined(USE_TI92PLUS) || defined(USE_V200))
				if(isBigKBD()){
					key=translateArrows(key);
				}
			#endif
			return key;
		}
		off();
	}
}
