// C Source File
// Created 7/7/2004; 2:09:23 PM

#include "defs.h"

#ifndef NO_HS
	//this coppies a SCORE vareable in a small way
	#ifdef VAT_FILES
		 asm(
		 ".globl HSC_init\n"
		 "HSC_init:\n"
		"moveq #((20+10*"_str(NAME_SIZE)")/4)-1,%d0\n"
		"copy_loop:\n"
		"	move.l (%a1)+,(%a0)+\n"
		"	dbf %d0,copy_loop\n"
		"rts\n");
	#endif

void GrayReset(void){
		PortRestore();
		//HW1 cleanup make sure that the LCD feches data from 0x4C00
		poke_w(0x600010,((long)LCD_MEM)/8);
}

	void __attribute__((__regparm__(1))) showHS(SCORES *hsc)
	{
		register short i=1,x=0,y=25;
		register char *name=hsc->names[0];
		register unsigned short *score=hsc->scores;
		char buff[sizeof("xx xxxxx xxxxx")];
		ClrScr();
		FontSetSys(F_6x8);
		do
		{
			sprintf(buff,SB("%u %s %u","%2u %6s %u"),i,name,*score++);
			DrawStr(x,y,buff,A_NORMAL);
			i++;
			y+=14;
			name+=NAME_SIZE;
			if(y==95)y=25,x=LCD_WIDTH/2+2;
		}while(i<=10);
		y=20;
		do{
			FastLine_Draw_R(LCD_MEM,0,y,LCD_WIDTH-1,y);
			y+=14;
		}while(y<20+6*14);

		FastLine_Draw_R(LCD_MEM,LCD_WIDTH/2,20,LCD_WIDTH/2,90);
		FontSetSys(F_8x10);
		DrawStr(SB(7,47),5,"TOP 10 HIGH SCORES",A_NORMAL);
		//FontSetSys(F_4x6);
		//DrawStr(2,94,EXTGRAPH_VERSION_PWDSTR,A_NORMAL);
	}
#endif

asm("	.even\n"
"	.globl	MyGrayDrawStr\n"
"MyGrayDrawStr:\n"
"	pea 0xEF007F\n"//4
"	pea (%a2)\n"//4
ASM_ROM_CALL(0x1A2)
"	move.w #4,-(%sp)\n"//2
"	move.l 4+4+2+8(%sp),-(%sp)\n"//4
"	move.l 4+4+2+4+4(%sp),-(%sp)\n"//4
ASM_ROM_CALL(0x1A9)
"	pea 0xEF007F\n"//4
"	pea 0xF00(%a2)\n"//4
//"	pea (%a3)\n"//4
ASM_ROM_CALL(0x1A2)
"	move.w #4,-(%sp)\n"//2
"	move.l 4+4+2+4+4+4+4+2+8(%sp),-(%sp)\n"//4
"	move.l 4+4+2+4+4+4+4+2+4+4(%sp),-(%sp)\n"//4
ASM_ROM_CALL(0x1A9)
"	lea (36,%sp),%sp\n"
"	rts");

unsigned short __attribute__((const,__regparm__(3))) computeScore(short numWalls,short startSpeed,short dificulty)
{
	return(((7-startSpeed)+8*(7-dificulty))*numWalls);
}
